const system = require("../../../system");
const uuidv4 = require('uuid/v4');
//内部通知调用
class UtilsChannelTmDeliveryService {
  constructor() {
    this.orderinfoDao = system.getObject("db.dbcorder.orderinfoDao");
  }
  //=================================修改渠道交付信息==============start======================================

  async addAliChannelTmApplicant(actionBody) {//新增ali渠道商标交付信息
    var itemResult = await this.getChannelDeliveryByChannelOrderNo(actionBody.orderNo, actionBody.channelOrderNo);
    if (itemResult.status != 0) {
      this.addChannelDelivery(actionBody.deliveryData, actionBody.orderNo, actionBody.channelOrderNo)
      return system.getResultSuccess();
    }
    return system.getResult(null, "添加失败，已经存在要添加的数据，30240");
  }
  async updateAliChannelTm(actionBody) {//修改ali渠道商标信息
    var itemResult = await this.getChannelDelivery(actionBody.orderNo);
    if (itemResult.status != 0) {
      return itemResult;
    }
    if (!itemResult.data || Object.keys(itemResult.data).length == 0) {
      return system.getResult(null, "修改失败，修改的数据为空，30230");
    }
    var apply = actionBody.apply;
    if (apply) {
      var dbApply = itemResult.data.apply;
      var applyKeys = Object.keys(apply);
      if (dbApply && applyKeys.length > 0) {
        for (let index = 0; index < applyKeys.length; index++) {
          const aKey = applyKeys[index];
          if (apply[aKey] != dbApply[aKey]) {
            itemResult.data.apply[aKey] = apply[aKey];
          }
        }
        this.putChannelDelivery(itemResult.data, actionBody.orderNo);
      }
    }
    var tmInfo = actionBody.tm;
    if (tmInfo) {
      itemResult.data.tm = tmInfo;
      this.putChannelDelivery(itemResult.data, actionBody.orderNo);
    }
  }
  async getAliChannelTmDelivery(actionBody) {//查询ali渠道商标交付信息
    var itemResult = await this.getChannelDelivery(actionBody.orderNo);
    if (itemResult.status != 0) {
      return itemResult;
    }
    if (!itemResult.data || Object.keys(itemResult.data).length == 0) {
      return system.getResult(null, "获取失败，数据为空，30233");
    }
    var returnParam = {
      apply: itemResult.data.apply,
      channelOrderNo: itemResult.data.channelOrderNo
    }
    return system.getResultSuccess(returnParam);
  }



  putChannelDelivery(data, orderNo) {//修改交付信息--内部调用
    var sql = "UPDATE `c_channel_delivery`  SET deliveryContent ='" + JSON.stringify(data) + "' where sourceOrderNo='" + orderNo + "'";
    this.orderinfoDao.customQuery(sql);
  }
  addChannelDelivery(data, orderNo, channelOrderNo) {//新增渠道交付信息--内部调用   
    var sql = "INSERT INTO  `c_channel_delivery` (`sourceOrderNo`,`channelOrderNo`,`deliveryContent`) VALUE('" +
      orderNo + "','" + channelOrderNo + "','" + JSON.stringify(data) + "')";
    this.orderinfoDao.customQuery(sql);
  }
  async getChannelDelivery(orderNo) {//查询渠道交付信息--内部调用
    var sql = "select * from c_channel_delivery where sourceOrderNo=:sourceOrderNo";
    var paramWhere = { sourceOrderNo: orderNo };
    var list = await this.orderinfoDao.customQuery(sql, paramWhere);
    if (!list || list.length == 0 || !list[0].deliveryContent) {
      return system.getResult(null, "get channel delivery data is empty，30250");
    }
    return system.getResultSuccess(list[0].deliveryContent);
  }
  async getChannelDeliveryByChannelOrderNo(orderNo, channelOrderNo) {//查询渠道交付信息--内部调用
    var sql = "select * from c_channel_delivery where sourceOrderNo=:sourceOrderNo and channelOrderNo=:channelOrderNo";
    var paramWhere = { sourceOrderNo: orderNo, channelOrderNo: channelOrderNo };
    var list = await this.orderinfoDao.customQuery(sql, paramWhere);
    if (!list || list.length == 0 || !list[0].deliveryContent) {
      return system.getResult(null, "get channel delivery data is empty，30253");
    }
    return system.getResultSuccess(list[0].deliveryContent);
  }
  //=================================修改渠道交付信息==============end======================================


}
module.exports = UtilsChannelTmDeliveryService;